


import socket
import random
import ClientBase
import numpy as np
from operator import itemgetter, attrgetter

Ranks = {
    '2': 1,
    '3': 2,
    '4': 3,
    '5': 4,
    '6': 5,
    '7': 6,
    '8': 7,
    '9': 8,
    'T': 9,
    'J': 10,
    'Q': 11,
    'K': 12,
    'A': 13
}
deRanks = {
    1: '2s',
    2: '3s',
    3: '4s',
    4: '5s',
    5: '6s',
    6: '7s',
    7: '8s',
    8: '9s',
    9: 'Ts',
    10: 'Js',
    11: 'Qs',
    12: 'Ks',
    13: 'As'
}

Suits = {
    'd': 1,
    'c': 2,
    'h': 3,
    's': 4
}


def dont_exists(hand,value):
    safe=True

    for i in range (0,5):
        if Ranks[hand[i][0]]==value:
            safe=False
    return safe



def check_semi_str(hand):
    value=-1
    for i in range(0,5):
        for j in range(0,5):
            for k in range(0,5):
                if Ranks[hand[i][0]]-Ranks[hand[j][0]]==1 and Ranks[hand[i][0]]-Ranks[hand[k][0]]==2 and dont_exists(hand,Ranks[hand[i][0]]+1):
                    value=hand[i][0]
                    return value
                elif Ranks[hand[i][0]]==2 and ( Ranks[hand[j][0]]==1 or Ranks[hand[k][0]]==1 ) and ( Ranks[hand[j][0]]==13 or Ranks[hand[k][0]]==13 ):
                    value = hand[i][0]
                    return value
    return value

def check_semi_flush(hand):
    re='n'
    for i in range(0,5):
        for j in range(0,5):
            for k in range(0,5):
                if hand[i][1]==hand[j][1] and hand[j][1]==hand[k][1] and i!=j and j!=k and i!=k :
                    re=hand[i][1]
                    return re
    return re

def get_unique(hand):
    for i in range(0, hand.__len__()):
        found = False
        value = hand[i]
        for j in range(0, hand.__len__()):
            if hand[i][0] == hand[j][0] and i != j:
                found = True
        if found == False:
            return value

def chech_for_4_str(hand):
    temp = hand
    for i in range(0, 5):
        v = hand[i]
        dupl = hand[i][0]
        start=1
        for j in range(0, 13):
            if deRanks[start] != dupl:
                temp[i] = deRanks[start]
                score = identify_hand(temp)
                if score[0] == 'Straight' or score[0] == 'StraightFlush':
                    temp[i] = v
                    return v
            start += 1
        temp[i] = v
    return -1


def get_thrown_index(hand,result,score):
    values=[]
    if result=='3OfAKind':#Throw the remaining 2 cards
        for i in range (0,5):
            if hand[i][0]==score[1]:
                continue
            else:
                values.append(hand[i])
        return values

    elif result=='TwoPairs':
        values.append(get_unique(hand))
        return values

    elif result=='OnePair':
        for i in range (0,5):
            if hand[i][0]!=score[1] and Ranks[hand[i][0]]<9:
                values.append(hand[i])
        return values
    elif result=='HighCard':
        semi_flush=check_semi_flush(hand)
        semi_str=check_semi_str(hand)
        one_str=chech_for_4_str(hand)

        if semi_flush!='n':#There is a semi_flush
            for i in range(0,5):
                if hand[i][1]!=semi_flush:
                    values.append(hand[i])
            return values

        elif one_str!=-1:
            values.append(one_str)
            return values


        elif semi_str!=-1:#There is a semi_str
            start=Ranks[semi_str]
            for i in range (0,5):
                if Ranks[hand[i][0]]!=start and Ranks[hand[i][0]]!=start-1 and Ranks[hand[i][0]]!=start-2 and Ranks[hand[i][0]]!=start-3:
                    if (start == 3 or start == 4 or start==2) and Ranks[hand[i][0]]==13:
                        continue
                    else:
                        values.append(hand[i])
            return values

        else:
            for i in range (0,5):
                if Ranks[hand[i][0]]<9 :
                    values.append(hand[i])
            return values


def identify_hand(Hand_):

    # Get the type of Hand
    def evaluateHand(Hand_):
        count = 0
        for card1 in Hand_:
            for card2 in Hand_:
                if (card1[0] == card2[0]) and (card1[1] != card2[1]):
                    count += 1
        return count

    # Use the "count" to analyse hand
    count_ = evaluateHand(Hand_)

    sub1 = 0
    score = [' ', ' ', ' ']

    if count_ == 12:
        for card1 in Hand_:
            for card2 in Hand_:
                if (card1[0] == card2[0]) and (card1[1] != card2[1]):
                    sub1 += 1
            if sub1 == 3:
                score = ['4OfAKind', card1[0], card1[1]]
                break

    elif count_ == 8:
        for card1 in Hand_:
            for card2 in Hand_:
                if (card1[0] == card2[0]) and (card1[1] != card2[1]):
                    sub1 += 1
            if sub1 == 1:
                sub1 = 0
            if sub1 == 2:
                score = ['FullHouse', card1[0], card1[1]]
                break

    elif count_ == 6:
        for card1 in Hand_:
            for card2 in Hand_:
                if (card1[0] == card2[0]) and (card1[1] != card2[1]):
                    sub1 += 1
            if sub1 == 2:
                score = ['3OfAKind', card1[0], card1[1]]
                break

    elif count_ == 4:
        needCard1 = ['', '']
        needCard2 = ['', '']
        for card1 in Hand_:
            for card2 in Hand_:
                # card1 keep the first hand card, card1 use every card to compare the card1
                if card1[0] == card2[0] and card1[1] != card2[1]:
                    if Suits[card1[1]] > Suits[card2[1]]:
                        if needCard1 == ['', '']:
                            needCard1 = card1
                    else:
                        if needCard1 == ['', '']:
                            needCard1 = card2
                if card1[0] == card2[0] and card1[1] != card2[1] \
                        and card1[0] != needCard1[0] and card2[0] != needCard1[0]:
                    if Suits[card1[1]] > Suits[card2[1]]:
                        if needCard2 == ['', '']:
                            needCard2 = card1
                    else:
                        if needCard2 == ['', '']:
                            needCard2 = card2
        if Ranks[needCard1[0]] > Ranks[needCard2[0]]:
            score = ['TwoPairs', needCard1[0], needCard1[1]]
        else:
            score = ['TwoPairs', needCard2[0], needCard2[1]]

    elif count_ == 2:
        for card1 in Hand_:
            for card2 in Hand_:
                if (card1[0] == card2[0]) and (card1[1] > card2[1]):
                    sub1 += 1
            if sub1 == 1:
                score = ['OnePair', card1[0], card1[1]]
                break

    elif count_ == 0:
        def sortHand(Hand_):
            hand_sorted_ = sorted([[card_, Ranks[card_[0]]] for card_ in Hand_], key=itemgetter(1))[:]
            return [card_[0] for card_ in hand_sorted_]

        Hand_ = sortHand(Hand_)
        score = ['HighCard', Hand_[4][0], Hand_[4][1]]

        if Hand_[0][1] == Hand_[1][1] == Hand_[2][1] == Hand_[3][1] == Hand_[4][1]:
            score = ['Flush', Hand_[4][0], Hand_[4][1]]

        if ( (Ranks[Hand_[4][0]] - Ranks[Hand_[3][0]] == 1) \
                and (Ranks[Hand_[3][0]] - Ranks[Hand_[2][0]] == 1) \
                and (Ranks[Hand_[2][0]] - Ranks[Hand_[1][0]] == 1) \
                and (Ranks[Hand_[1][0]] - Ranks[Hand_[0][0]] == 1) ) or(Hand_[4][0]=='A' and Hand_[3][0]=='5' and Hand_[2][0]=='4' and Hand_[1][0]=='3' and Hand_[0][0]=='2') :
            score = ['Straight', Hand_[4][0], Hand_[4][1]]

            if Hand_[0][1] == Hand_[1][1] == Hand_[2][1] == Hand_[3][1] == Hand_[4][1]:
                score = ['StraightFlush', Hand_[4][0], Hand_[4][1]]
                if Hand_[0][0]=='T' and Hand_[1][0]=='J' and Hand_[2][0]=='Q' and Hand_[3][0]=='K' and Hand_[4][0]=='A':
                    score = ['RoyalFlush', Hand_[4][0], Hand_[4][1]]

    else:
        exit(5664)
    return score

def getstren(score):

    if score[0] == 'HighCard':
        return 'Very Low'
    if score[0] == 'OnePair' and Ranks[score[1]]<=8:
        return 'Low'

    if (score[0] == 'TwoPairs') or (score[0] == 'OnePair' and Ranks[score[1]]>8):
        return 'Medium'
    if score[0] != '4OfAKind' or score[0] != 'RoyalFlush' or score[0] != 'StraightFlush' :
        return 'High'
    else:
        return 'Very High'

hand = ['Jc', 'Th', 'Jd', '9h', 'Qd']

score = identify_hand(hand)
print score
print getstren(score)
result=score[0]

print get_thrown_index(hand,result,score)



















