import numpy as np
from sklearn.model_selection import train_test_split
from sklearn import svm
from sklearn import tree
import Youssef_and_Mohamed_Agent as Client
Ranks = {
    '2': 1,
    '3': 2,
    '4': 3,
    '5': 4,
    '6': 5,
    '7': 6,
    '8': 7,
    '9': 8,
    'T': 9,
    'J': 10,
    'Q': 11,
    'K': 12,
    'A': 13
}

Types = {
    'HighCard':      100,
    'OnePair':       200,
    'TwoPairs':      300,
    '3OfAKind':      400,
    'Straight':      500,
    'Flush':         600,
    'FullHouse':     700,
    '4OfAKind':      800,
    'StraightFlush': 900,
    'RoyalFlush':1000
}

size=0
number=0
def get_numbers(P1_hand,P1_rank,P1_coin,R,P1_bet,result,n):
    l=[0]*(n+5)
    l[0]=Types[P1_hand]
    l[1]=Ranks[P1_rank]
    l[2]=P1_coin
    for i in range (0,R.__len__()):
        l[i+3]=R[i]
    l[n+3]=P1_bet
    l[n+4]=result
    return l









def evaluate(n):
    global size
    global number
    size=n
    F = open("History.txt","r")
    s = F.read()

    l=s.splitlines()
    number=l.__len__()
    data=[]
    R=[0]*n

    for i in range (0,l.__len__()):
        round=l[i].split()
        P1_hand=round[0]
        P1_rank=round[1]
        P1_coin=int(round[2])
        # count=0
        P1_bet=0
        # P2_bet=0
        # action=None
        for j in range (0,n):
            v=round[j+3]
            R[j]=int(v)
        # print round
        # print round[n+3]
        # print n
        P1_bet=int(round[n+3])
        result=int(round[n+4])
        result=get_numbers(P1_hand,P1_rank,P1_coin,R,P1_bet,result,n)
        data.append(result)



    Data=np.empty((number,size+5))
    for i in range (0,number):
        for j in range (0,size+5):
            Data[i][j]=data[i][j]


# print Data




    print('Length of Total Data:', len(Data))
    train_size=0.2
    Train_set, Test_set = train_test_split(Data, test_size=train_size)
    # print type(Train_set)
    Input_train = Train_set[:, :(size+4)]     # input features
    Target_train = Train_set[:, (size+4)]  # output labels

    Input_test = Test_set[:, :(size+4)]
    Target_test = Test_set[:, (size+4)]

    clf = tree.DecisionTreeClassifier()

    clf = clf.fit(Input_train, Target_train)

    PredictedOutcome = clf.predict(Input_test)

    count0=0
    count1=0
    # print "Henaaaaaaaaaaaa", PredictedOutcome
    # print Target_test
    for i in range (0,PredictedOutcome.shape[0]):
        if PredictedOutcome[i]==1.:
            count1+=1
        else:
            count0+=1
    # print "0 :", count0
    # print "1 :", count1
    if count1>count0:
        return 1
    else:
        return 0

    # print "Henaaaaaaaaaaaa" , PredictedOutcome
    # print Target_test
    # Number_of_Correct_Predictions = len([i for i, j in zip(PredictedOutcome, Target_test) if i == j])
    #
    # print ('*******************************************')
    # print('Number of Correct Predictions using scikit-learn library DecisionTreeClassifier:', Number_of_Correct_Predictions, 'Out_of:', len(PredictedOutcome),
    #       'Number of Test Data')
    # print('Accuracy of Prediction in Percent:', (Number_of_Correct_Predictions/float(len(PredictedOutcome)))*100)


def identify(hand,raises,win,ante,chips,all_in):#1 for correct #2 for aggressive #3 for bluffing #0 for unknown yet

    # print hand
    # print raises
    # print win
    # print ante
    # print chips
    # print all_in

    raises = int(raises)
    ante = int(ante)
    chips = int(chips)

    if chips==0:
        return 0

    if hand==0:

        if all_in>=8:
            return 3
        elif raises>=chips and win==0:
            return 3
        if all_in>=4:
            return 2
        elif raises>=chips or (raises>=chips-25 and chips>25):
            return 2
        elif raises>=chips/2 and win==0:
            return 2
        else:
            return 0








    score=Client.identify_hand(hand)
    k=score[0]
    rank=score[1]
    suite=score[2]
    strength=Client.getstren(score)
    r=get_ratio(raises,ante,chips)

    if strength=='Very Low':
        if (raises>3*ante and ante>=20) or raises>chips/3:
            return 3
        elif r==3:
            return 3
        elif raises/chips >0.25 and raises/chips <0.65:
            return 2
        else:
            return 1

    elif strength=='Low':
        if r==3:
            return 3
        if r==2 and raises/chips > 0.4:
            return 3
        if r==2:
            return 2
        else:
            return 1
    elif strength=='Medium':
        if raises>=chips or raises>chips-50 or r==3:
            return 2
        else:
            return 1
    else:
        return 1







def get_ratio(raises,ante,chips):#1 for low #2 for medium #3 for high
    raises=int(raises)
    ante=int(ante)
    chips=int(chips)
    if raises/chips >= 0.5:
        return 3
    if ante>50:
        if raises>3*ante or raises>2*ante:
            return 3
        # if  ante/raises< 0.60 and ante/raises > 0.35:
        #     return 2
        # if raises<1.6*ante and raises>
        if raises <= 2*ante:
            return 2
        else:
            return 1
    if raises/chips>0.35 and raises/chips < 0.6:
        return 2
    else:
        return 1



def identify_agents(n):
    result=[0]*n
    index=0
    size=n-1
    F = open("identification.txt", "r")
    s = F.read()

    l = s.splitlines()
    data=l
    start=0

    for i in range (0,n+size):
        if  data[start][i]==' ':
            continue
        v=get(data,i)
        # print index
        # print result.__len__()
        result[index]=v
        index+=1
    for i in range(0,n):
        if result[i]==1:
            result[i]='Correct'
        elif result[i] == 2:
            result[i] = 'Aggressive'
        elif result[i] == 3:
            result[i] = 'Bluffing'
    return result
    F.close()



def get(data,i):
    count=[0]*3
    for j in range (0,data.__len__()):
        if data[j]=='':
            continue
        # print "erorrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrrr",data[j][i]
        if int(data[j][i])!=-1:
            count[int(data[j][i])-1]+=1
    # print count
    return count.index(max(count))+1

